import 'package:flutter/material.dart';

int selectedIndex = 0;

class PhoenixBottomMenuUHF extends StatelessWidget {
  const PhoenixBottomMenuUHF({
    Key? key,
    required this.navBarItems,
    required this.onTabChange,
    this.selectedTabColor,
    this.unselectedTabColor,
  }) : super(key: key);

  final Function(int index) onTabChange;

  /// Set of navigation bar item in array
  final List<NavBarItem> navBarItems;

  /// Navigation bar decoration
  final Color? selectedTabColor;
  final Color? unselectedTabColor;

  @override
  Widget build(BuildContext context) {
    return BottomNavigationBar(
        currentIndex: selectedIndex,
        selectedItemColor: selectedTabColor ?? Colors.red,
        unselectedItemColor: unselectedTabColor ?? Colors.black54,
        items: bottomNavigationBarItem(selectedTabColor ?? Colors.red,
            unselectedTabColor ?? Colors.black54, navBarItems),

        /// Callback the navigation Bar to widget
        onTap: (index) {
          selectedIndex = index;
          onTabChange(index);
        });
  }

  /// Loop set of list according for navigation bar item
  bottomNavigationBarItem(Color _selectedTabColor, Color _unselectedTabColor,
      List<NavBarItem> items) {
    List<BottomNavigationBarItem> listItem = <BottomNavigationBarItem>[];
    for (int num = 0; num < items.length; num++) {
      listItem.add(BottomNavigationBarItem(
          icon: Image.asset(items[num].image!,
              color: selectedIndex == num
                  ? _selectedTabColor
                  : _unselectedTabColor,
              height: 25,
              width: 25),
          label: items[num].name!));
    }
    return listItem;
  }
}

class NavBarItem {
  String? image;
  String? name;

  NavBarItem(this.name, this.image);
}
