import 'package:flutter/material.dart';
import 'package:flutter/cupertino.dart';
import 'dart:io' show Platform;

void phoenixGenericPopUp({
  required BuildContext context,
  //message related
  required Widget popUpContentWidget,
  //title related
  Widget? popUpTitleWidget,
  //ensure button related
  Widget? ensureWidget,
  //cancel button related
  Widget? cancelWidget,
  // type != 1 will not dismiss button on ensure click
  int type = 1,
  bool barrierDismissible = false,
  VoidCallback? ensureCallback,
  VoidCallback? cancelCallback,
}) {
  List<Widget> actions = [];

  if (cancelWidget != null) {
    if (cancelWidget.runtimeType == Text) {
      if ((cancelWidget as Text).data!.isNotEmpty) {
        actions.add(CupertinoButton(
          child: cancelWidget,
          onPressed: () async {
            Navigator.of(context).pop();
            cancelCallback!();
          }, // 关闭对话框
        ));
      }
    } else {
      actions.add(CupertinoButton(
        child: cancelWidget,
        onPressed: () async {
          Navigator.of(context).pop();
          cancelCallback!();
        }, // 关闭对话框
      ));
    }
  }
  if (ensureWidget != null) {
    actions.add(CupertinoButton(
      child: ensureWidget,
      onPressed: () async {
        if (type == 1) {
          Navigator.of(context).pop();
          ensureCallback!();
        } else {
          ensureCallback!();
        }
      },
    ));
  } else {
    actions.add(CupertinoButton(
      child: const Text(
        "Confirm",
      ),
      onPressed: () async {
        if (type == 1) {
          Navigator.of(context).pop();
          ensureCallback!();
        } else {
          ensureCallback!();
        }
      },
    ));
  }
  if (Platform.isIOS) {
    showDialog(
      barrierDismissible: barrierDismissible,
      context: context,
      builder: (context) {
        return WillPopScope(
          onWillPop: () async => barrierDismissible,
          child: CupertinoAlertDialog(
            // title: Text((popUpTitleWidget as Text).data!),
            title: (() {
              if (popUpTitleWidget.runtimeType == Text) {
                if ((popUpTitleWidget as Text).data!.isNotEmpty) {
                  return popUpTitleWidget;
                } else {
                  return null;
                }
              } else {
                return popUpTitleWidget;
              }
            }()),
            content: popUpContentWidget,
            actions: actions,
          ),
        );
      },
    );
  } else {
    showDialog(
      context: context,
      barrierDismissible: barrierDismissible,
      builder: (context) {
        return WillPopScope(
          onWillPop: () async => barrierDismissible,
          child: AlertDialog(
            title: (() {
              if (popUpTitleWidget.runtimeType == Text) {
                if ((popUpTitleWidget as Text).data!.isNotEmpty) {
                  return popUpTitleWidget;
                } else {
                  return null;
                }
              } else {
                return popUpTitleWidget;
              }
            }()),
            content: popUpContentWidget,
            actions: actions,
          ),
        );
      },
    );
  }
}
